	.segment "STARTUP"
Reset:
	sei					; disable IRQ
	cld					; clear decimal mode(nes doesn't use)
	ldx #$40			; disable sound IRQ
	stx JOY2
	ldx #$ff
	txs					; set stack pointer
	inx					; X = 0
	stx PPUCTRL			; disable NMI
	stx PPUMASK			; disable sprites/background
	stx DMC_FREQ		; disable IRQ, 428 cpu cycles NTSC 398 cpu cycles PAL
VBlankWait1:
	bit PPUSTATUS		; check for vblank
	bpl VBlankWait1		; loop until vblank is finished
	txa					; accumulator = 0
ClearRAM:
	sta $0000, x		; clear RAM $0000 - $0099
	sta $0100, x		; clear RAM $0100 - $0199
	sta $0300, x		; clear RAM $0300 - $0399
	sta $0400, x		; clear RAM $0400 - $0499
	sta $0500, x		; clear RAM $0500 - $0599
	sta $0600, x		; clear RAM $0600 - $0699
	sta $0700, x		; clear RAM $0700 - $0799
	lda #$ff
	sta $0200, x		; sprites off screen
	lda #$00			; accumulator = 0
	inx
	bne ClearRAM
VBlankWait2:
	bit PPUSTATUS		; check for vblank
	bpl VBlankWait2		; loop until vblank is finished ppu is ready at that point
	lda #$02
    sta OAMDMA			; OAM DMA high address $0200
	jmp Start			; jump to start of game code